*****************************************************************************
* Modulname:	_ApLet_
* Modultype:	ApLet
* Dest.Comp.:	HP 39G/40G
* Language:	System RPL
* Author:	Detlef Mueller, Bellerbek 33, 22559 Hamburg, Germany
* Interface:
* Description:	Empty but full featured "embedded code ApLet" (CAPLET)
*		frame. Replace all _ApLet_ references by the name of
*		your ApLet. Check for comments marked w/ "*>>>"
* To do:
*
* Copyright:	(c) 1999-2002 by Detlef Mueller. ALL rights reserved.
*
* $Id: aplet.s 1.4 1999/05/02 02:39:45 Detlef Exp Detlef $
*
* $Log: aplet.s $
*****************************************************************************

    TITLE	_ApLet_


*****************************************************************************
*		ENTRY POINTS
*****************************************************************************

ASSEMBLE

=IsEurope?	EQU	#196B4		Supported but unlisted entry

RPL


*****************************************************************************
*		INCLUDE FILES
*****************************************************************************

    INCLUDE	common39.h


*****************************************************************************
*		APLET LAYOUT
*****************************************************************************

ASSEMBLE
	Dir_Head 7,_ApLet_,601
*>>>		 ^
*		 +-- Length in chars of the following name
RPL


EXTERNAL	view6_CAPLE		( tType for taking over Note View   )
EXTERNAL	view7_CAPLE		( tType for taking over Sketch View )


	{				( tType variable, 1st var in dir    )
	    topic_CAPLET		( Topic type -- embedded code aplet )
	    view01_CAPLET		( Plot type  -- points to our lib   )
	    view23_CAPLET		( Table type )
	    view45_CAPLET		( Symb type )
	    xREADNOTE			( Note type, use xDFLTNOTE for R/W, )
					( view6_CAPLET to take over the view)
	    view7_CAPLE 		( Pict type, here disabled. altern: )
					( xREADPICT [RO], xDFLTPICT [R/W]   )
	}


    INCLUDE	share.h 		( Minimal variable set neccessary   )
					( for every ApLet type		    )

ASSEMBLE
	Vfield	L34,IntTable

	CON(5)	=DOHSTR 		Linktable variable, provides links
	REL(5)	endLink 		to the objects w/in the next variable

	Link	_Main
	Link	_MainDisp
	Link	_MainKeys
	Link	_MainMenu

	Link	_Run

*>>>	Add links to more routines here, they must
*	be paired w/ the defines just below

endLink
RPL

DEFINE	Main		INT_00
DEFINE	MainDisp	INT_01
DEFINE	MainKeys	INT_02
DEFINE	MainMenu	INT_03

DEFINE	Run		INT_04

*>>>	Add defines for more routines here
*	INT_05..INT_09,INT_0A..INT_0F
*	#n INT_NN


ASSEMBLE
	Vfield	IntTable,DirVar

	CON(5)	=DOHSTR 		Code variable, containes the sRPL
	REL(5)	codeEnd 		objects encapsulated in a HSTR
RPL


*****************************************************************************
*		DEFINES
*****************************************************************************

DEFINE	FOURTY		FORTY		( Well... )

DEFINE	kpShift 	kpRightShift
DEFINE	kpAShft 	kpANoShift
DEFINE	kcShift 	kcRightShift


*>>>	The following few defines deal w/ the variable
*	storage. For each variable to add, 1. extend
*	the list found near the end of this file and
*	2. add the @/! defines. A 3rd value will be
*	mapped to TopicVar3, a 4th to TopicVar4 and
*	so on. You may choose more meaningfull names.

DEFINE	@Par		LastBut3
DEFINE	!Par		LastBut3 REPLACE DROP

DEFINE	Par1@		TopicVar1@
DEFINE	Par1!		TopicVar1!
DEFINE	Par2@		TopicVar2@
DEFINE	Par2!		TopicVar2!


*****************************************************************************
*		OBJECTS
*****************************************************************************


*** _Main *******************************************************************
* Interface :	( --> )
* Description : Main program
*****************************************************************************

NAMELESS	_Main
::
    {	MINUSONE
	{				( This is the VIEWS menu	  )
	    {	"Enter _ApLet_"
		:: ZERO INT_00		( Enter via plot view		  )
		;
	    }
	    {	"Reset"                 ( Reset entry, remove it if you   )
		:: EIGHT INT_00 	( won't provide an ApLet reset    )
		;
	    }
	    {	"View note"
		NotesViewUI
	    }
	}
	StndVar
**	StndReset			( -3 never passed unless	  )
					( _Aplet_ == 'MiscAplet           )
	StndEntry
	StndExit
    }
    BinLookup case EVAL

    EIGHT #= IT 			( # may be:	ApLet entered by:  )
    ::	{ TRUE FOUR } TOTEMPOB		( ZERO	plot view		   )
	!Par				( ONE	plot setup view 	   )
    ;					( TWO	numeric view		   )
					( THREE num. setup view 	   )
					( FOUR	symbolic view		   )
					( FIVE	symb. setup view	   )
					( SIX	note view, if using tType  )
					(	entry view6_CAPLET	   )
					( SEVEN sketch view,if using tType )
					(	entry view7_CAPLET	   )
					( EIGHT do reset, if enabled	   )

    ( Note for all following quoted objects: as )
    ( they grow further, I'd suggest to move    )
    ( them to become [named] INT_xx objects.	)

    '                                   ( **View entry** )
    ::					( *Load parameter into TopicVars* )
	@Par INNERDUP			( --> ... #n #n )

	ZERO_DO (DO)
	    SWAP OVER			( --> ... #n ob #n )
	    INDEX@#- TopicVarN!
	LOOP

	DROP

	fnErrorBeep			( Set Beep on/off according to Par1 )
	Par1@ ITE			( SF_Sound set means beep off... )
	    ClrSysFlag
	    SetSysFlag
    ;

    '                                   ( **View exit** )
    ::					( *Save TopicVars into parameter* )
	@Par LENCOMP DUP		( --> #n )

	#1+_ONE_DO (DO)
	    INDEX@ TopicVarN@ SWAP	( --> ... ob #n )
	LOOP

	%0AllTopicVs			( Clear all topic vars )

	{}N !Par			( Store parameter into ApLet )

	fnErrorBeep SetSysFlag		( Beep off is default )
	fnIODevice  ClrSysFlag		( WIRE is default )

	SetDAsBad			( Signal bad display )
**	DropJunk			( Drop any leftovers )
    ;

    ' MainDisp                          ( **View display** )

    ' MainKeys                          ( **View hard key handler** )

    TRUE				( **Allow normal keys** )

    '                                   ( **Initial menu** )
    ::	MainMenu
    ;

    ONE 				( **Initial menu page** )

    '                                   ( **Error object** )
    ::	TURNMENUON RECLAIMDISP		( Enshure AGROB to be displayed )
	ERRJMP
    ;
;

*** _MainDisp ***************************************************************
* Interface :	( --> )
* Description : Main view display handler
*****************************************************************************

NAMELESS	_MainDisp
::
    DA3OK?NOTIT ?DispMenu		( Redraw menu if not ok )

    DA1OK? KEYINBUFFER? OR ?SEMI	( Leave if DA1 is ok or key in buffer )

    RECLAIMDISP 			( Clr rows 0-55 )

*>>>	Redraw main display here

    "_ApLet_ display\1F"
    Par2@ DISPN 			( Very simple sample... :*)

    SetDA1Valid 			( Signal main display valid )
;

*** _MainKeys ***************************************************************
* Interface :	( --> )
* Description : Main view hardkeys handler
*****************************************************************************

NAMELESS	_MainKeys
::					( `Main' keybinding )
    kpNoShift #=casedrop		( Check/process unshifted keys )
    ::
	DUP#<7 casedrpfls		( Enable menukeys )

	kcEnter ?CaseKeyDef		( Enter: call Run )
	::  TakeOver
	    Run
	;

	kcNegate ?CaseKeyDef		( -X: Toggle sound on/off )
	::  TakeOver

	    Par1@ NOT Par1!

	    fnErrorBeep
	    Par1@ ITE
		ClrSysFlag
		SetSysFlag

	    SetDA3Bad			( Signal to redraw menu )
	;

	kcUpArrow ?CaseKeyDef		( Up: move main-text one line up )
	::  TakeOver

	    Par2@
	    ONE #=casedrop DoBadKey

	    #1- Par2!
	    SetDA1Bad			( Signal to redraw main display )
	;

	kcDownArrow ?CaseKeyDef 	( Down: move main-text one line down )
	::  TakeOver

	    Par2@
	    SEVEN #=casedrop DoBadKey

	    #1+ Par2!
	    SetDA1Bad			( Signal to redraw main display )
	;

*>>>	Add other key handling here

	kcShift #=casedrpfls		( Allow shift )

	kcPlotView ?CaseKeyDef DoBadKey ( Disallow Plot/Symb/Num views )
	kcSymbView ?CaseKeyDef DoBadKey
	kcNumView  ?CaseKeyDef DoBadKey
	kcVarsMenu ?CaseKeyDef DoBadKey ( Disallow Vars/Math menus, )
	kcMathMenu ?CaseKeyDef DoBadKey ( they map in the menu bar  )

	DUP kpNoShift IsTaskSwKey? casedrpfls

	DROP 'DoBadKeyT                 ( Illegal key )
    ;

    kpShift #=casedrop			( Check/process shifted keys )
    ::
	kcShift #=casedrpfls		( Allow shift )

	kcOn #=casedrpfls		( Allow power off )

*>>>	Add other shifted key handling here

	kcPlotView ?CaseKeyDef DoBadKey ( Disallow Plot/Symb/Num views )
	kcSymbView ?CaseKeyDef DoBadKey
	kcNumView  ?CaseKeyDef DoBadKey
	kcMathMenu ?CaseKeyDef DoBadKey ( Disallow Sketch view )

	DUP kpShift IsTaskSwKey? casedrpfls

	DROP 'DoBadKeyT                 ( Illegal key )
    ;

*>>>	Add alpha key handling here

    2DUP IsTaskSwKey? case2drpfls	( Task-switch key not handled above ? )

    2DROP 'DoBadKeyT                    ( Illegal keyplane )
;


*** _MainMenu ***************************************************************
* Interface :	( --> )
* Description : Main view menu definition
*****************************************************************************

NAMELESS	_MainMenu
{					( **Initial menu** )
    {					( Call Run )
	"RUN"
	::  TakeOver
	    Run
	;
    }
    NullMenuKey 			( Just some blank entries )
    NullMenuKey
    NullMenuKey
    {
	::  TakeOver			( Toggle betw. IR/WIRE, JFF )
	    fnIODevice SysITE
		"IR"
		"WIRE"
	    MakeBoxLabel
	;
	::  TakeOver

	    IsEurope? caseDoBadKey	( Don't toggle on a 40G )

	    fnIODevice DUP
	    SysITE
		ClrSysFlag
		SetSysFlag

	    SetDA3Bad			( Redraw menu )
	;
    }
    {
	::  TakeOver
	    "BEEP" Par1@ Box/StdLabel
	;
	::  TakeOver

	    Par1@ NOT Par1!

	    fnErrorBeep
	    Par1@ ITE
		ClrSysFlag
		SetSysFlag

	    SetDA3Bad			( Signal to redraw menu )
	;
    }
}

*** _Run ********************************************************************
* Interface :	( --> )
* Description : Play a little melody
*****************************************************************************

NAMELESS	_Run
::
    300 554 OVER 659 SEVENTYFIVE 740 150
    6PICK 4PICK 6PICK 4PICK OVER

    SIX ZERO
    DO
	setbeep
    LOOP

    SetDA1Bad				( Signal to redraw main display )
;

*****************************************************************************
*		End of Objects
*****************************************************************************

ASSEMBLE
codeEnd
RPL


*****************************************************************************
*		PARAMETER
*****************************************************************************

ASSEMBLE
	Vfield DirVar,DirCode
RPL
  {
	TRUE			( Par1 -- Beep on/off flag. Here ON. )
	FOUR			( Par2 -- Line to display the main-text )

*>>>	Add more parameter here

  }


*****************************************************************************
*		AltViews -- should be none for this ApLet
*****************************************************************************

ASSEMBLE
	Vfield DirCode,DirAlt
RPL
  { }


*****************************************************************************
*		ApLet note -- most time (c) & quick reference
*****************************************************************************

ASSEMBLE
	Vfield DirAlt,DirNot

	CON(5)	=DOCSTR
	REL(5)	noteEnd

	NIBASC	" _ApLet_ for the '39G\n"
	NIBASC	"\n"
	NIBASC	" '2002 Detlef Mller\n"
	NIBASC	"<detlef.m@hamburg.de>\n"
	NIBASC	"\n"
	NIBASC	"   $Revision: 1.4 $"
*		 1234567890123456789012
noteEnd
RPL


*****************************************************************************
*		SketchSet -- here none.
*****************************************************************************

ASSEMBLE
	Vfield DirNot,DirEnd
RPL
  { }


******************************************************************************
*			End of _Aplet_.S
******************************************************************************
